/////////////////////////////////////////////////////////////////////
//
//  Copyright (C) 1996 Microsoft Corporation. All Rights Reserved.
//
//  File: Helworld2.c (Originality Helworld.c)
//
//  Simplified Direct3D Retained-Mode example, based on 
//  the "Globe" SDK sample.
//                              [FULL screen support by Ryo Shi-3z]
//	[tXN[ɑΉAXN[Z[oƂĈꉞ삷]
//
/////////////////////////////////////////////////////////////////////

#define INITGUID           // Must precede other defines and includes
						   // GUIDgp邱Ƃ錾

#include <windows.h>
#include <malloc.h>        // Required by memset call
						   // memsetďoߕKv

#include <winbase.h>

#include <d3drmwin.h>
#include <string.h>

#define MAX_DRIVERS 5           // Maximum D3D drivers expected  
								// D3DhCo̍ő吔

// Global variables
// O[oϐ

LPDIRECTDRAW lpDD = NULL;			// DirectDraw object (modified by Ryo-Shi-3z)
LPDIRECT3D	lpD3D = NULL;			// Direct3D object (modified by Ryo-Shi-3z)
LPDIRECT3DRM lpD3DRM = NULL;        // Direct3DRM object 
LPDIRECTDRAWCLIPPER lpDDClipper;// DirectDrawClipper object 
	LPDIRECTDRAWSURFACE lpDDSfront = NULL,
						lpDDSback = NULL,
						lpDDSz = NULL; // modified by Ryo Shi-3z
	LPDIRECT3DDEVICE	lpD3Ddev = NULL; // modified by Ryo Shi-3z
	LPDIRECTDRAWPALETTE	lpDDpal = NULL; // modifeied by Ryo Shi-3z

BOOL isActive = FALSE;
struct _myglobs { // O[oϐQ

	

    LPDIRECT3DRMDEVICE dev ;    // Direct3DRM device 
    LPDIRECT3DRMVIEWPORT view ; // Direct3DRM viewport through which 
                                // the scene is viewed
    LPDIRECT3DRMFRAME scene ;   // Master frame in which others are 

                                // placed 
    LPDIRECT3DRMFRAME camera ;  // Frame describing the user's POV 

    GUID DriverGUID[MAX_DRIVERS];     // GUIDs of available D3D drivers 
    char DriverName[MAX_DRIVERS][50]; // Names of available D3D drivers 
    int  NumDrivers;                  // Number of available D3D drivers 
    int  CurrDriver;                  // Number of D3D driver currently
                                      // being used 

    BOOL bQuit;                 // Program is about to terminate 

    BOOL bInitialized;          // All D3DRM objects are initialized 
    BOOL bMinimized;            // Window is minimized 

    int BPP;                    // Bit depth of the current display mode

} myglobs;

// Function prototypes.
 
static BOOL InitApp(HINSTANCE, int);
long FAR PASCAL WindowProc(HWND, UINT, WPARAM, LPARAM);
static BOOL EnumDrivers(HWND win);
static HRESULT WINAPI enumDeviceFunc(LPGUID lpGuid, 
    LPSTR lpDeviceDescription, LPSTR lpDeviceName, 

    LPD3DDEVICEDESC lpHWDesc, LPD3DDEVICEDESC lpHELDesc, 
    LPVOID lpContext);
static DWORD BPPToDDBD(int bpp);
static BOOL CreateDevAndView(LPDIRECTDRAWCLIPPER lpDDClipper, 
    int driver, int width, int height);
static BOOL SetRenderState(void);
static BOOL RenderLoop(void);
static BOOL MyScene(LPDIRECT3DRMDEVICE dev, LPDIRECT3DRMVIEWPORT view, 
    LPDIRECT3DRMFRAME scene, LPDIRECT3DRMFRAME camera);
void MakeMyFrames(LPDIRECT3DRMFRAME lpScene, LPDIRECT3DRMFRAME lpCamera,

    LPDIRECT3DRMFRAME * lplpLightFrame1, 
    LPDIRECT3DRMFRAME * lplpWorld_frame);
void MakeMyLights(LPDIRECT3DRMFRAME lpScene, LPDIRECT3DRMFRAME lpCamera, 
    LPDIRECT3DRMFRAME lpLightFrame1, 
    LPDIRECT3DRMLIGHT * lplpLight1, LPDIRECT3DRMLIGHT * lplpLight2);
void SetMyPositions(LPDIRECT3DRMFRAME lpScene, 
    LPDIRECT3DRMFRAME lpCamera, LPDIRECT3DRMFRAME lpLightFrame1, 
    LPDIRECT3DRMFRAME lpWorld_frame);
void MakeMyMesh(LPDIRECT3DRMMESHBUILDER * lplpSphere3_builder,int p);

void MakeMyWrap(LPDIRECT3DRMMESHBUILDER sphere3_builder, 
                LPDIRECT3DRMWRAP * lpWrap);
void AddMyTexture(LPDIRECT3DRMMESHBUILDER lpSphere3_builder, 
                  LPDIRECT3DRMTEXTURE * lplpTex);
static void CleanUp(void);

/////////////////////////////////////////////////////////////////////
// 
// WinMain
// Initializes the application and enters a message loop.
// The message loop renders the scene until a quit message is received.
// 
// AvP[VAbZ[W[vɓ܂B
// bZ[W[v͏IbZ[W󂯎܂ŃV[_O
// ܂B
//
/////////////////////////////////////////////////////////////////////
 
int PASCAL
WinMain (HINSTANCE this_inst, HINSTANCE prev_inst, LPSTR cmdline, 
    int cmdshow)
{
    MSG     msg;
    HACCEL  accel = NULL;
    int     failcount = 0;  // Number of times RenderLoop has failed 
							// RenderLoops

    prev_inst;
    cmdline;


	// R}hCIvVɁu/svw肳ꂽƂ̂݃XN[Z[o
	// Ƃē삵܂B
	if(strstr(cmdline,"/p")!=NULL)return; // vpeBʗp
//	if(strstr(cmdline,"/o")!=NULL)return; // vpeBݒp
//	if(strstr(cmdline,"/s")==NULL)return; // XN[Z[o[p


    // Create the window and initialize all objects needed to begin 
    // rendering.
	// EChE𐶐A_OɕKvȂׂẴIuWFNg
	// ܂B

     
    if (!InitApp(this_inst, cmdshow))
        return 1;

    while (!myglobs.bQuit) {
        
        // Monitor the message queue until there are no pressing
        // messages.
		// bZ[WEL[j^[܂B
         
        while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {
            if (!TranslateAccelerator(msg.hwnd, accel, &msg)) {
                TranslateMessage(&msg);

                DispatchMessage(&msg);
            }
        }
        
        // If the app is not minimized, not about to quit, and D3DRM has
        // been initialized, begin rendering.
         
////////////////////////////////////////////////////////// Original code 
//        if (!myglobs.bMinimized && !myglobs.bQuit && 
//             myglobs.bInitialized) 
////////////////////////////////////////////////////////////////////////
        if (isActive && 
             myglobs.bInitialized) 
		{
				if(lpDDSfront != NULL){
					if(lpDDSfront->lpVtbl->IsLost(lpDDSfront)){
						lpDDSfront->lpVtbl->Restore(lpDDSfront);
						myglobs.view->lpVtbl->ForceUpdate(myglobs.view,0, 0, 640, 480);
					}
					if(lpDDSz->lpVtbl->IsLost(lpDDSz)){
						lpDDSz->lpVtbl->Restore(lpDDSz);
						myglobs.view->lpVtbl->ForceUpdate(myglobs.view,0, 0, 640, 480);
					}
				}

            // Attempt to render a frame. If rendering fails more than 
            // twice, abort execution.
                 
            if (!RenderLoop())
                ++failcount;

            if (failcount > 2) {
                CleanUp();
                break;
            }
        }
    }
    return msg.wParam;
}



/////////////////////////////////////////////////////////////////////
// 
// InitApp
// Creates window and initializes all objects necessary to begin 
// rendering.
//
// EChE𐶐A_OJn邽߂ɕKvȑSĂ
// IuWFNgB
/////////////////////////////////////////////////////////////////////
 
static BOOL
InitApp(HINSTANCE this_inst, int cmdshow)
{
    HWND win;
    HDC hdc;
    WNDCLASS wc;
    RECT rc;

	DDSURFACEDESC ddsd;
	DDSCAPS ddscaps;
	PALETTEENTRY        pe[256];
	int i;



    // Set up and register the window class.
	// EChENXݒAWXgB
     
    wc.style = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc = WindowProc;

    wc.cbClsExtra = 0;
    wc.cbWndExtra = sizeof(DWORD);
    wc.hInstance = this_inst;
    wc.hIcon = LoadIcon(this_inst, "AppIcon");
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
    wc.lpszMenuName = NULL;        
    wc.lpszClassName = "D3DRM Example";
    if (!RegisterClass(&wc))
        return FALSE;
    
    // Initialize the global variables.
	// O[oϐ[
     
    memset(&myglobs, 0, sizeof(myglobs));


    // Create the window.
	// EChE𐶐
     
    win =
        CreateWindow
        (   "D3DRM Example",            // Class 
            "Hello World (Direct3DRM)", // Title bar 
            WS_VISIBLE | WS_POPUP |WS_SYSMENU,// modified by Ryo Shi-3z
            0,              // Init. x pos 
            0,              // Init. y pos 
            GetSystemMetrics(SM_CXSCREEN),                        // Init. x size 
            GetSystemMetrics(SM_CXSCREEN),                        // Init. y size 

            NULL,                       // Parent window 
            NULL,                       // Menu handle 
            this_inst,                  // Program handle 
            NULL                        // Create parms 
        );
    if (!win)
        return FALSE;

	ShowCursor(FALSE);
   
    // Record the current display bits-per-pixel.
	// ݂̃fBXvC̃rbgEp[EsNZL^B
     
    hdc = GetDC(win);
    myglobs.BPP = GetDeviceCaps(hdc, BITSPIXEL);
    ReleaseDC(win, hdc);

lpDD =  0;
lpD3D = 0;

   
    // Enumerate the D3D drivers and select one.
	// D3DhCo񋓂AЂƂIԁB

     
    if (!EnumDrivers(win))
        return FALSE;
   
/////////////////////following modified by Ryo Shi-3z /////////////////////////////////

	// if fail to enumrate then, Create DirectDraw object with HEL
	// 񋓂ł݂Ȃsꍇ́AHELIB

	if(!lpDD)
		DirectDrawCreate(NULL, &lpDD, NULL);

	lpDD->lpVtbl->SetCooperativeLevel(lpDD,win, 
						DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN | DDSCL_ALLOWMODEX);
	lpDD->lpVtbl->SetDisplayMode(lpDD,640, 480, 16);

	// fill the surface discripter
	// T[tFXfBXNv^ݒ

    memset(&ddsd, 0, sizeof(DDSURFACEDESC));
    ddsd.dwSize         = sizeof(DDSURFACEDESC);
    ddsd.dwFlags        = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
    ddsd.ddsCaps.dwCaps	= 
						DDSCAPS_PRIMARYSURFACE | DDSCAPS_FLIP | DDSCAPS_COMPLEX | DDSCAPS_3DDEVICE;
    ddsd.dwBackBufferCount      = 1;

	//  Create primary surface
	// vC}T[tFX𐶐

	lpDD->lpVtbl->CreateSurface(lpDD,&ddsd, &lpDDSfront, NULL);

    ddscaps.dwCaps = DDSCAPS_BACKBUFFER;
	lpDDSfront->lpVtbl->GetAttachedSurface(lpDDSfront,&ddscaps, &lpDDSback);
/*
	[8rbg[hgȂ߁AĂ܂]


		// T[tFX̃pbgZbg
	
		// Jg̃VXepbg擾
		hdc = GetDC(NULL);
		GetSystemPaletteEntries(hdc, 0, 256, pe);
		ReleaseDC(NULL, hdc);

		// [hI[ɂȂĂ邢̓ʂȃGgݒ肵܂
		pe[0].peFlags   = D3DPAL_READONLY;
		pe[254].peFlags = D3DPAL_READONLY;
		pe[255].peFlags = D3DPAL_READONLY;
		for (i = 1; i < 254; i++) pe[i].peFlags = D3DPAL_FREE;
		pe[254].peRed   = 0;	// 邢O[̃Ggݒ
		pe[254].peGreen = 255;
		pe[254].peBlue  = 0;
        
		// DirectDrawgApbgݒ肵܂
		lpDD->lpVtbl->CreatePalette(lpDD,DDPCAPS_8BIT, pe, &lpDDpal, NULL);
		lpDDSfront->lpVtbl->SetPalette(lpDDSfront,lpDDpal);
		lpDDSback->lpVtbl->SetPalette(lpDDSback,lpDDpal);
*/
    memset(&ddsd, 0, sizeof(DDSURFACEDESC));
    ddsd.dwSize             = sizeof(DDSURFACEDESC);
    ddsd.dwFlags            = DDSD_WIDTH | DDSD_HEIGHT | DDSD_CAPS | DDSD_ZBUFFERBITDEPTH;
    ddsd.dwWidth            = 640;
    ddsd.dwHeight           = 480;
    ddsd.ddsCaps.dwCaps     = DDSCAPS_ZBUFFER;
    ddsd.dwZBufferBitDepth  = 16;

	//  Create z-buffer
	//  zobt@𐶐B

	lpDD->lpVtbl->CreateSurface(lpDD,&ddsd, &lpDDSz, NULL);
	lpDDSback->lpVtbl->AddAttachedSurface(lpDDSback,lpDDSz);



//////////////////// end of modified by Ryo Shi-3z //////////////////////////////////


    // Create the D3DRM object and the D3DRM window object.
	// D3DRMIuWFNg𐶐B
     
    lpD3DRM = NULL;
    Direct3DRMCreate(&lpD3DRM);
    
    // Create the master scene frame and camera frame.
	// }X^[V[t[ƃJt[𐶐B
     
    lpD3DRM->lpVtbl->CreateFrame(lpD3DRM, NULL, &myglobs.scene);
    lpD3DRM->lpVtbl->CreateFrame(lpD3DRM, myglobs.scene, 
        &myglobs.camera);
    myglobs.camera->lpVtbl->SetPosition(myglobs.camera, myglobs.scene, 

        D3DVAL(0.0), D3DVAL(0.0), D3DVAL(0.0));

    // Create a DirectDrawClipper object and associate the 
    // window with it.
	// DirectDrawClipperIuWFNg𐶐AEChEɊ֘AÂ
	// [̓tXN[̂ߊ]
     
//    DirectDrawCreateClipper(0, &lpDDClipper, NULL);
//    lpDDClipper->lpVtbl->SetHWnd(lpDDClipper, 0, win);
    
    // Create the D3DRM device by using the selected D3D driver.
	// D3DhCoD3DRMfoCX𐶐
     
    GetClientRect(win, &rc);
    if (!CreateDevAndView(lpDDClipper, myglobs.CurrDriver, rc.right, 
            rc.bottom)) {
        return FALSE;

    }
    
    // Create the scene to be rendered.
	// V[𐶐B
     
    if (!MyScene(myglobs.dev, myglobs.view, myglobs.scene, 
            myglobs.camera))
        return FALSE;
    
    myglobs.bInitialized = TRUE;  // Initialization completed 
    
    // Display the window.
	// EChE\B
     
    ShowWindow(win, cmdshow);
    UpdateWindow(win);

    return TRUE;
}


/////////////////////////////////////////////////////////////////////
//
// WindowProc
// Main window message handler.
// CEChEbZ[Wnh
//
/////////////////////////////////////////////////////////////////////
 
LONG FAR PASCAL WindowProc(HWND win, UINT msg, 
    WPARAM wparam, LPARAM lparam)
{
    RECT r;
    PAINTSTRUCT ps;
    LPDIRECT3DRMWINDEVICE lpD3DRMWinDev;
	static mousemove=0;

    switch (msg)    {

		// 񐧍삷̂̓XN[Z[oȂ̂ŁA}EXA
		// L[ꂽ肵璼ɏIdlB

    case WM_MOUSEMOVE:if(mousemove++ <= 1)break;
				//EChEƓɑĂꍇ邽߁AJEgB
    case WM_LBUTTONDOWN:
    case WM_RBUTTONDOWN:
    case WM_KEYDOWN:
		DestroyWindow(win);

		break;
    case WM_DESTROY:
        CleanUp();
        break;
    case WM_ACTIVATEAPP:

        {
			isActive = (BOOL)wparam ? TRUE : FALSE;
			if(isActive){
			
			}else{
				ShowCursor(TRUE);
			}
        // Create a Windows-specific D3DRM window device to handle this
        // message.

/*         
        LPDIRECT3DRMWINDEVICE lpD3DRMWinDev;
        if (!myglobs.dev)
            break;
        myglobs.dev->lpVtbl->QueryInterface(myglobs.dev, 
            &IID_IDirect3DRMWinDevice, (void **) &lpD3DRMWinDev);
        lpD3DRMWinDev->lpVtbl->HandleActivate(lpD3DRMWinDev, 
            (WORD) wparam);
        lpD3DRMWinDev->lpVtbl->Release(lpD3DRMWinDev);
*/
        }
        break;
/*
    case WM_PAINT:
        if (!myglobs.bInitialized || !myglobs.dev)
            return DefWindowProc(win, msg, wparam, lparam);
       
        // Create a Windows-specific D3DRM window device to handle this
        // message.
         
        if (GetUpdateRect(win, &r, FALSE)) {
            BeginPaint(win, &ps);
            myglobs.dev->lpVtbl->QueryInterface(myglobs.dev, 
                &IID_IDirect3DRMWinDevice, (void **) &lpD3DRMWinDev);

            if (FAILED(lpD3DRMWinDev->lpVtbl->HandlePaint(lpD3DRMWinDev, 
                ps.hdc)))
            lpD3DRMWinDev->lpVtbl->Release(lpD3DRMWinDev);
            EndPaint(win, &ps);

        }
        break;*/
    default:
        return DefWindowProc(win, msg, wparam, lparam);
    }
    return 0L;
}


/////////////////////////////////////////////////////////////////////
//
// EnumDrivers
// Enumerate the available D3D drivers and choose one.
// p\D3DhCo񋓂AIB
//
/////////////////////////////////////////////////////////////////////
 
static BOOL
EnumDrivers(HWND win)
{
    HRESULT rval;

    // Create a DirectDraw object and query for the Direct3D interface 
    // to use to enumerate the drivers.
	// DirectDrawIuWFNg𐶐ADirect3DC^[tF[XNG[
	// Ă݂B
     
    DirectDrawCreate(NULL, &lpDD, NULL);
	
    rval = lpDD->lpVtbl->QueryInterface(lpDD, &IID_IDirect3D, 
        (void**) &lpD3D);
    if (rval != DD_OK) {
        lpDD->lpVtbl->Release(lpDD);
        return FALSE;
    }
    
    // Enumerate the drivers, setting CurrDriver to -1 to initialize the
    // driver selection code in enumDeviceFunc.
	// hCo񋓂AenumDeviceFuncɓnCurrDriver-1ɏB
     
    myglobs.CurrDriver = -1;
    lpD3D->lpVtbl->EnumDevices(lpD3D, enumDeviceFunc, 
        &myglobs.CurrDriver);
    
    // Ensure at least one valid driver was found.

     
    if (myglobs.NumDrivers == 0) {
        return FALSE;
    }
   
    return TRUE;
}


/////////////////////////////////////////////////////////////////////
//
// enumDeviceFunc
// Callback function that records each usable D3D driver's name 
// and GUID. Chooses a driver and sets *lpContext to this driver.
// p\D3DhCo̖OGUIDL^R[obN֐B
// hCoIAhCoւ*lpContextݒ肷B
//
/////////////////////////////////////////////////////////////////////
 
static HRESULT
WINAPI enumDeviceFunc(LPGUID lpGuid, LPSTR lpDeviceDescription, 
    LPSTR lpDeviceName, LPD3DDEVICEDESC lpHWDesc, 
    LPD3DDEVICEDESC lpHELDesc, LPVOID lpContext)

{
    static BOOL hardware = FALSE; // Current start driver is hardware 
    static BOOL mono = FALSE;     // Current start driver is mono light 
    LPD3DDEVICEDESC lpDesc;
    int *lpStartDriver = (int *)lpContext;
   
    // Decide which device description should be consulted.
	// ǂ̃foCXLqqK\肷B
     
    lpDesc = lpHWDesc->dcmColorModel ? lpHWDesc : lpHELDesc;
    
    // If this driver cannot render in the current display bit-depth, 
    // skip it and continue with the enumeration.
	// hCõ݂fBXvC̃rbg[xŃ_OłȂ
	// ꍇAXLbvA񋓂𑱂B

     
    if (!(lpDesc->dwDeviceRenderBitDepth & BPPToDDBD(myglobs.BPP)))
        return D3DENUMRET_OK;
    
    // Record this driver's name and GUID.
	// hCo̖OGUIDL^
     
    memcpy(&myglobs.DriverGUID[myglobs.NumDrivers], lpGuid, 
        sizeof(GUID));
    lstrcpy(&myglobs.DriverName[myglobs.NumDrivers][0], lpDeviceName);
   
    // Choose hardware over software, RGB lights over mono lights.
	// \tgEFAn[hEFAD悵APFCgRGBCgD悷B
     
    if (*lpStartDriver == -1) {
        
        // This is the first valid driver.
         
        *lpStartDriver = myglobs.NumDrivers;
        hardware = lpDesc == lpHWDesc ? TRUE : FALSE;
        mono = lpDesc->dcmColorModel & D3DCOLOR_MONO ? TRUE : FALSE;
    } else if (lpDesc == lpHWDesc && !hardware) {
        
        // This driver is hardware and the start driver is not.
         
        *lpStartDriver = myglobs.NumDrivers;
        hardware = lpDesc == lpHWDesc ? TRUE : FALSE;
        mono = lpDesc->dcmColorModel & D3DCOLOR_MONO ? TRUE : FALSE;

    } else if ((lpDesc == lpHWDesc && hardware ) || 
               (lpDesc == lpHELDesc && !hardware)) {
        if (lpDesc->dcmColorModel == D3DCOLOR_MONO && !mono) {
            
            // This driver and the start driver are the same type, and 
            // this driver is mono whereas the start driver is not.
             
            *lpStartDriver = myglobs.NumDrivers;
            hardware = lpDesc == lpHWDesc ? TRUE : FALSE;
            mono = lpDesc->dcmColorModel & D3DCOLOR_MONO ? TRUE : FALSE;

        }
    }
    myglobs.NumDrivers++;
    if (myglobs.NumDrivers == MAX_DRIVERS)
        return (D3DENUMRET_CANCEL);
    return (D3DENUMRET_OK);
}

/////////////////////////////////////////////////////////////////////
//
// BPPToDDBD
// Converts bits-per-pixel to a DirectDraw bit-depth flag.
// rbgEp[EsNZDirectDraw̃rbg[xtO֕ϊB
//
/////////////////////////////////////////////////////////////////////

static DWORD
BPPToDDBD(int bpp)
{
    switch(bpp) {
        case 1:
            return DDBD_1;
        case 2:
            return DDBD_2;
        case 4:
            return DDBD_4;
        case 8:
            return DDBD_8;
        case 16:

            return DDBD_16;
        case 24:
            return DDBD_24;
        case 32:
            return DDBD_32;
        default:
            return 0;
    }
}


/////////////////////////////////////////////////////////////////////
//
// CreateDevAndView
// Create the D3DRM device and viewport with the given D3D driver and 
// with the specified size.
// ^ꂽD3DhCoD3DRMfoCXAr[|[g𐶐B
// 
/////////////////////////////////////////////////////////////////////
 
static BOOL
CreateDevAndView(LPDIRECTDRAWCLIPPER lpDDClipper, int driver, 
    int width, int height)
{
    HRESULT rval;

    // Create the D3DRM device from this window by using the specified 
	// D3DRMfoCX̃EChE琶B

    // Create D3D driver.  D3DhCo𐶐B
     
	lpDD->lpVtbl->QueryInterface(lpDD,&IID_IDirect3D, (void**) &lpD3D); // modified by Ryo Shi-3z
	
//    lpD3DRM->lpVtbl->CreateDeviceFromClipper(lpD3DRM, lpDDClipper, 
//        &myglobs.DriverGUID[driver], width, height, &myglobs.dev); // Original code

	lpDDSback->lpVtbl->QueryInterface(lpDDSback, &myglobs.DriverGUID[driver],
										(LPVOID *)&lpD3Ddev);// modified by Ryo Shi-3z

	lpD3DRM->lpVtbl->CreateDeviceFromD3D(lpD3DRM,lpD3D,lpD3Ddev,&myglobs.dev);// modified by Ryo Shi-3z
	myglobs.dev->lpVtbl->SetBufferCount(myglobs.dev,2);
    width = 640; height=480;

    // Create the D3DRM viewport by using the camera frame.  Set the 
    // background depth to a large number. The width and height
    // might have been slightly adjusted, so get them from the device.
	// Jt[D3DRMr[|[g𐶐AwifvX傫
	// ɐݒ肷Bƕ͒Ă邽߁AfoCX擾[]
     
//   width = myglobs.dev->lpVtbl->GetWidth(myglobs.dev);
//   height = myglobs.dev->lpVtbl->GetHeight(myglobs.dev);
	
/*	lpD3DRM->lpVtbl->SetDefaultTextureColors(lpD3DRM,16);
	lpD3DRM->lpVtbl->SetDefaultTextureShades(lpD3DRM,8);
	myglobs.dev->lpVtbl->SetShades(myglobs.dev,4); // Original code
*/	
	lpD3DRM->lpVtbl->SetDefaultTextureColors(lpD3DRM,16);// modified by Ryo Shi-3z
	lpD3DRM->lpVtbl->SetDefaultTextureShades(lpD3DRM,16);// modified by Ryo Shi-3z
	myglobs.dev->lpVtbl->SetShades(myglobs.dev,32);// modified by Ryo Shi-3z
	myglobs.dev->lpVtbl->SetDither(myglobs.dev,TRUE);// modified by Ryo Shi-3z
	myglobs.dev->lpVtbl->SetQuality(myglobs.dev,D3DRMRENDER_GOURAUD);// modified by Ryo Shi-3z

    rval = lpD3DRM->lpVtbl->CreateViewport(lpD3DRM, myglobs.dev, 
        myglobs.camera, 0, 0, width, height, &myglobs.view);
    if (rval != D3DRM_OK) {
        myglobs.dev->lpVtbl->Release(myglobs.dev);
        return FALSE;
    }
    rval = myglobs.view->lpVtbl->SetBack(myglobs.view, D3DVAL(5000.0));
    if (rval != D3DRM_OK) {
        myglobs.dev->lpVtbl->Release(myglobs.dev);
        myglobs.view->lpVtbl->Release(myglobs.view);
        return FALSE;
    }

    
    // Set the render quality, fill mode, lighting state,
    // and color shade info.
	// _Oiݒ肵A[hAݒAJ[Ae𖄂߂B
     
    if (!SetRenderState())
        return FALSE;
    return TRUE;
}



/////////////////////////////////////////////////////////////////////
//
// SetRenderState
// Set the render quality and shade information.
// _OiƉAeݒ肷B
//
/////////////////////////////////////////////////////////////////////
 
BOOL
SetRenderState(void)
{
    HRESULT rval;
    
    // Set the render quality (light toggle, fill mode, shade mode).
	// _Oiݒ肷B
     
    rval = myglobs.dev->lpVtbl->SetQuality(myglobs.dev, 
        D3DRMLIGHT_ON | D3DRMFILL_SOLID | D3DRMSHADE_GOURAUD);

    if (rval != D3DRM_OK) {
        return FALSE;
    }
    
    // If you want to change the dithering mode, call SetDither here.
	// AfBUOE[hɂ΂SetDitherĂԁB

    // If you want a texture quality other than D3DRMTEXTURE_NEAREST
    // (the default value), call SetTextureQuality here.
	// AD3DRMTEXTURE_NEARESTȊÕeNX`i悯΁A
	// SetTextureQualityĂԁB
        
    // Set shade information based on current bits-per-pixel.
	// ݂̃rbgEp[EsNZx[XɁAAeݒ肷B
     
    switch (myglobs.BPP) {
        case 1:
            if (FAILED(myglobs.dev->lpVtbl->SetShades(myglobs.dev, 4)))
                goto shades_error;

            if (FAILED(lpD3DRM->lpVtbl->
                    SetDefaultTextureShades(lpD3DRM, 4)))
                goto shades_error;
            break;
        case 16:
            if (FAILED(myglobs.dev->lpVtbl->SetShades(myglobs.dev, 32)))
                goto shades_error;
            if (FAILED(lpD3DRM->lpVtbl->
                    SetDefaultTextureColors(lpD3DRM, 64)))
                goto shades_error;
            if (FAILED(lpD3DRM->lpVtbl->
                    SetDefaultTextureShades(lpD3DRM, 32)))

                goto shades_error;
            break;
        case 24:
        case 32:
            if (FAILED(myglobs.dev->lpVtbl->
                    SetShades(myglobs.dev, 256)))
                goto shades_error;
            if (FAILED(lpD3DRM->lpVtbl->
                    SetDefaultTextureColors(lpD3DRM, 64)))
                goto shades_error;
            if (FAILED(lpD3DRM->lpVtbl->
                    SetDefaultTextureShades(lpD3DRM, 256)))
                goto shades_error;

            break;
    }
    return TRUE;
shades_error:
    return FALSE;
}


/////////////////////////////////////////////////////////////////////
//
// RenderLoop
// Clear the viewport, render the next frame, and update the window.
// r[|[gNA[AȂt[`BăEChE
// Abvf[gB
//
/////////////////////////////////////////////////////////////////////
 
static BOOL
RenderLoop()
{
    HRESULT rval;
	HDC		hDc;

    // Tick the scene.
	// V[̎v̐ji߂B
     
    rval = myglobs.scene->lpVtbl->Move(myglobs.scene, D3DVAL(1.0));
    if (rval != D3DRM_OK) {
        return FALSE;
    }

	// Flip to front buffer
	// tgobt@Ƀtbv

	rval = lpDDSfront->lpVtbl->Flip(lpDDSfront,NULL,DDFLIP_WAIT);
	if (rval != D3DRM_OK) {
        return FALSE;
    }
	
    
    // Clear the viewport.
	// r[|[gNA

     
    rval = myglobs.view->lpVtbl->Clear(myglobs.view);
    if (rval != D3DRM_OK) {
        return FALSE;
    }
   
    // Render the scene to the viewport.
	// r[|[gɃV[`oB
     
    rval = myglobs.view->lpVtbl->Render(myglobs.view, myglobs.scene);
    if (rval != D3DRM_OK) {
        return FALSE;
    }

/*	rval = lpDDSback->lpVtbl->GetDC(lpDDSback,&hDc); //\
	if(rval == D3D_OK){
		TextOut(&hDc,0,0,"Globe",5);
	}
	lpDDSback->lpVtbl->ReleaseDC(lpDDSback,&hDc);*/
    
    // Update the window.
	// EChEAbvf[gB
     
    rval = myglobs.dev->lpVtbl->Update(myglobs.dev);
    if (rval != D3DRM_OK) {
        return FALSE;
    }



    return TRUE;
}

/////////////////////////////////////////////////////////////////////
//
// MyScene
// Calls the functions that create the frames, lights, mesh, and
// texture. Releases all interfaces on completion.
// ̊֐̓t[ACgAbVăeNX`𐶐B
// đSẴC^[tF[XJB
//
/////////////////////////////////////////////////////////////////////

BOOL
MyScene(LPDIRECT3DRMDEVICE dev, LPDIRECT3DRMVIEWPORT view,
    LPDIRECT3DRMFRAME lpScene, LPDIRECT3DRMFRAME lpCamera)
{
    LPDIRECT3DRMFRAME lpLightframe1 = NULL;
    LPDIRECT3DRMFRAME lpWorld_frame = NULL;

    LPDIRECT3DRMLIGHT lpLight1      = NULL;
    LPDIRECT3DRMLIGHT lpLight2      = NULL;
    LPDIRECT3DRMTEXTURE lpTex       = NULL;
    LPDIRECT3DRMWRAP lpWrap         = NULL;
    LPDIRECT3DRMMESHBUILDER lpSphere3_builder = NULL;
    LPDIRECT3DRMMESHBUILDER lpSphere3_builder2 = NULL;

    MakeMyFrames(lpScene, lpCamera, &lpLightframe1, &lpWorld_frame);
    MakeMyLights(lpScene, lpCamera, lpLightframe1, &lpLight1,
        &lpLight2);
    SetMyPositions(lpScene, lpCamera, lpLightframe1, lpWorld_frame);
    MakeMyMesh(&lpSphere3_builder,1);
//    MakeMyMesh(&lpSphere3_builder2,2);

    MakeMyWrap(lpSphere3_builder, &lpWrap);
    AddMyTexture(lpSphere3_builder, &lpTex);

    // If you need to create a material (for example, to create
    // a shiny surface), call CreateMaterial and SetMaterial here.
	// A}eA𐶐Kv΁ACreateMaterial
	// SetMaterialĂԁB

    // Now that the visual object has been created, add it
    // to the world frame.
	// 悢Aڂɂ݂iBWAȁjIuWFNgꂽB
	// [ht[ɒǉB

    lpWorld_frame->lpVtbl->AddVisual(lpWorld_frame, 
        (LPDIRECT3DRMVISUAL) lpSphere3_builder);
//    lpWorld_frame->lpVtbl->AddVisual(lpWorld_frame, 
//        (LPDIRECT3DRMVISUAL) lpSphere3_builder2);

    lpLightframe1->lpVtbl->Release(lpLightframe1);
    lpWorld_frame->lpVtbl->Release(lpWorld_frame);

    lpSphere3_builder->lpVtbl->Release(lpSphere3_builder);
//    lpSphere3_builder->lpVtbl->Release(lpSphere3_builder2);
    lpLight1->lpVtbl->Release(lpLight1);
    lpLight2->lpVtbl->Release(lpLight2);
    lpTex->lpVtbl->Release(lpTex);
    lpWrap->lpVtbl->Release(lpWrap);

    return TRUE;
}
/////////////////////////////////////////////////////////////////////
//
// MakeMyFrames
// Create frames used in the scene.
// V[Ŏgt[𐶐B
//
/////////////////////////////////////////////////////////////////////

void MakeMyFrames(LPDIRECT3DRMFRAME lpScene, LPDIRECT3DRMFRAME lpCamera,
    LPDIRECT3DRMFRAME * lplpLightFrame1,
    LPDIRECT3DRMFRAME * lplpWorld_frame)
{
    lpD3DRM->lpVtbl->CreateFrame(lpD3DRM, lpScene, lplpLightFrame1);
    lpD3DRM->lpVtbl->CreateFrame(lpD3DRM, lpScene, lplpWorld_frame);

}

/////////////////////////////////////////////////////////////////////
//
// MakeMyLights
// Create lights used in the scene.
// V[ŎgCg𐶐B
//
/////////////////////////////////////////////////////////////////////

void MakeMyLights(LPDIRECT3DRMFRAME lpScene, LPDIRECT3DRMFRAME lpCamera, 
    LPDIRECT3DRMFRAME lpLightFrame1, 
    LPDIRECT3DRMLIGHT * lplpLight1, LPDIRECT3DRMLIGHT * lplpLight2)
{
    lpD3DRM->lpVtbl->CreateLightRGB(lpD3DRM, D3DRMLIGHT_DIRECTIONAL, 
        D3DVAL(0.9), D3DVAL(0.9), D3DVAL(0.9), lplpLight1);

                          
    lpLightFrame1->lpVtbl->AddLight(lpLightFrame1, *lplpLight1);

    lpD3DRM->lpVtbl->CreateLightRGB(lpD3DRM, D3DRMLIGHT_AMBIENT, 
        D3DVAL(0.1), D3DVAL(0.1), D3DVAL(0.1), lplpLight2);
    
    lpScene->lpVtbl->AddLight(lpScene, *lplpLight2);
}

/////////////////////////////////////////////////////////////////////
//
// SetMyPositions
// Set the positions and orientations of the light, camera, and 
// world frames. 
// CgAJA[ht[̈ʒuƌݒ肷B
//
/////////////////////////////////////////////////////////////////////

void SetMyPositions(LPDIRECT3DRMFRAME lpScene, 
    LPDIRECT3DRMFRAME lpCamera, LPDIRECT3DRMFRAME lpLightFrame1, 
    LPDIRECT3DRMFRAME lpWorld_frame)
{

    lpLightFrame1->lpVtbl->SetPosition(lpLightFrame1, lpScene, 

        D3DVAL(2), D3DVAL(0.0), D3DVAL(22));

	// Ƃł킹▭̃JAO
    lpCamera->lpVtbl->SetPosition(lpCamera, lpScene, 
        D3DVAL(-5.0), D3DVAL(10.0), D3DVAL(0.0));
    lpCamera->lpVtbl->SetOrientation(lpCamera, lpScene, 
        D3DVAL(0.35), D3DVAL(-0.65), D3DVAL(1.0), 
        D3DVAL(-0.15), D3DVAL(1.0), D3DVAL(0.5));
                                        
    lpWorld_frame->lpVtbl->SetPosition(lpWorld_frame, lpScene, 
        D3DVAL(0.0), D3DVAL(0.0), D3DVAL(15));
    lpWorld_frame->lpVtbl->SetOrientation(lpWorld_frame, lpScene, 

        D3DVAL(0.0), D3DVAL(0.0), D3DVAL(1.0),
        D3DVAL(0.0), D3DVAL(1.0), D3DVAL(0.0));

                                
    lpWorld_frame->lpVtbl->SetRotation(lpWorld_frame, lpScene, 
        D3DVAL(0.0), D3DVAL(1.0), D3DVAL(0.0), D3DVAL(0.05));
}



/////////////////////////////////////////////////////////////////////
//
// MakeMyMesh
// Create MeshBuilder object, load, scale, and color the mesh.
//@bVr_[IuWFNg𐶐A[hA傫A
// FhsB
//
/////////////////////////////////////////////////////////////////////

void MakeMyMesh(LPDIRECT3DRMMESHBUILDER * lplpSphere3_builder,int a)
{
    lpD3DRM->lpVtbl->CreateMeshBuilder(lpD3DRM, lplpSphere3_builder);

    (*lplpSphere3_builder)->lpVtbl->Load(*lplpSphere3_builder, 
        "sphere3.x", NULL, D3DRMLOAD_FROMFILE, NULL, NULL);
/*
	switch(a){
		case 1:
		    (*lplpSphere3_builder)->lpVtbl->Load(*lplpSphere3_builder, 
		        "EARTH.x", NULL, D3DRMLOAD_FROMFILE, NULL, NULL);
			break;
		case 2:
		    (*lplpSphere3_builder)->lpVtbl->Load(*lplpSphere3_builder, 
		        "maru.x", NULL, D3DRMLOAD_FROMFILE, NULL, NULL);
			break;
	}
*/
    (*lplpSphere3_builder)->lpVtbl->Scale(*lplpSphere3_builder,
        D3DVAL(2), D3DVAL(2), D3DVAL(2));
      
    // Set sphere to white to avoid unexpected texture-blending results.
	//[IuWFNgf[^قȂ邽߂͊̕]

    (*lplpSphere3_builder)->lpVtbl->SetColorRGB(*lplpSphere3_builder, 
        D3DVAL(1), D3DVAL(1), D3DVAL(1));
}
/////////////////////////////////////////////////////////////////////
//
// MakeMyWrap
// Creates and applies wrap for texture.
// eNX`p̃bv𐶐E蓖ĂB[͖gp]
//
/////////////////////////////////////////////////////////////////////

void MakeMyWrap(LPDIRECT3DRMMESHBUILDER sphere3_builder, 
                LPDIRECT3DRMWRAP * lpWrap)
{
    D3DVALUE miny, maxy, height;
    D3DRMBOX box;

    sphere3_builder->lpVtbl->GetBox(sphere3_builder, &box);

    maxy = box.max.y;
    miny = box.min.y;

    height = maxy - miny;

    lpD3DRM->lpVtbl->CreateWrap
        (lpD3DRM, D3DRMWRAP_CYLINDER, NULL,
        D3DVAL(0.0), D3DVAL(0.0), D3DVAL(0.0),
        D3DVAL(0.0), D3DVAL(1.0), D3DVAL(0.0),
        D3DVAL(0.0), D3DVAL(0.0), D3DVAL(1.0),
        D3DVAL(0.0), D3DDivide(miny, height),
        D3DVAL(1.0), D3DDivide(D3DVAL(1.0), height),
        lpWrap);

    (*lpWrap)->lpVtbl->Apply(*lpWrap, (LPDIRECT3DRMOBJECT)
        sphere3_builder);

}
/////////////////////////////////////////////////////////////////////
//
// AddMyTexture
// Creates and applies wrap for texture.
// eNX`蓖ĂB
//
/////////////////////////////////////////////////////////////////////

void AddMyTexture(LPDIRECT3DRMMESHBUILDER lpSphere3_builder, 
    LPDIRECT3DRMTEXTURE * lplpTex)
{
    lpD3DRM->lpVtbl->LoadTexture(lpD3DRM, "emap2.bmp", lplpTex);
//    lpD3DRM->lpVtbl->LoadTexture(lpD3DRM, "hello.ppm", lplpTex);

    // If you need a color depth other than the default (16), 
    // call IDirect3DRMTexture::SetShades here.

    lpSphere3_builder->lpVtbl->SetTexture(lpSphere3_builder, *lplpTex);

}

/////////////////////////////////////////////////////////////////////
//
// CleanUp
// Release all D3DRM objects and set the bQuit flag.
// SĂD3DRMIuWFNgJAbQuittOݒ肷B
//
/////////////////////////////////////////////////////////////////////

void
CleanUp(void)
{
    myglobs.bInitialized = FALSE;
    if(myglobs.scene!=NULL)myglobs.scene->lpVtbl->Release(myglobs.scene);
    if(myglobs.camera!=NULL)myglobs.camera->lpVtbl->Release(myglobs.camera);
    if(myglobs.view!=NULL)myglobs.view->lpVtbl->Release(myglobs.view);
    if(myglobs.dev!=NULL)myglobs.dev->lpVtbl->Release(myglobs.dev);

	if(lpD3Ddev!=NULL)lpD3Ddev->lpVtbl->Release(lpD3Ddev);// modified by Ryo Shi-3z


	if(lpDDSz!=NULL)lpDDSz->lpVtbl->Release(lpDDSz);// modified by Ryo Shi-3z
	if(lpDDSback!=NULL)lpDDSback->lpVtbl->Release(lpDDSback);// modified by Ryo Shi-3z
	if(lpDDSfront!=NULL)lpDDSfront->lpVtbl->Release(lpDDSfront);// modified by Ryo Shi-3z

	// Restore display mode fBXvC[h𕜌B
	if(lpDD!=NULL)lpDD->lpVtbl->RestoreDisplayMode(lpDD);// modified by Ryo Shi-3z

    if(lpD3DRM!=NULL)lpD3DRM->lpVtbl->Release(lpD3DRM);
    //lpDDClipper->lpVtbl->Release(lpDDClipper);
    if(lpD3D!=NULL)lpD3D->lpVtbl->Release(lpD3D);// modified by Ryo Shi-3z
	if(lpDD!=NULL)lpDD->lpVtbl->Release(lpDD);// modified by Ryo Shi-3z

	ShowCursor(TRUE);

    myglobs.bQuit = TRUE;
}


